/***************************************************************************
 *   Copyright (C) 2007-2010 by Helge Kortendieck  alan@kasmithee.de       *
 *   aboutHelp.cpp  -  show about or help dialog                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.         *
 ***************************************************************************/
#include "abouthelp.h"

aboutHelp::aboutHelp( QDialog* parent, Qt::WindowFlags fl )
        : QDialog( parent, fl )
{
	uih.setupUi( &wHelp );
	connect(uih.pB_Close, SIGNAL( clicked() ), this, SLOT( closeDlg() ) );
}

aboutHelp::~aboutHelp()
{
}


void aboutHelp::showAbout( )                  // show about dialog
{
  if( wHelp.isVisible() == true ) {
    wHelp.hide();
  }
  sHelp = tr( "<html><body>"
              "ldoss - launch delayed on session start, Qt4 based.<p>"
              "Version 0.8.3 , (C) 2010 by Helge Kortendieck<p>"
              "This program is released under GPL3 or later."
              "</body></html>" ) ;
  uih.tb_Help->setHtml( sHelp );
  wHelp.setWindowTitle( tr( "about ldoss" ) );
  wHelp.resize(550, 180);
  wHelp.show();
}

void aboutHelp::showHelp( )                   // show help dialog
{
  if( wHelp.isVisible() == true ) {
    wHelp.hide();
  }
  sHelp = tr( "<html><body>"
              "<a name=""Top""><b>Table of content</b></a><br>"
              "<a href=""#Intro"">Introduction</a><br>"
              "<a href=""#Usage"">Starting</a><br>"
              "<a href=""#Options"">Options</a><br>"
              "<a href=""#Faq"">FAQ</a><br>"
              "<a href=""#Credits"">Credits</a><p>"

              "<hr>"
              "<a name=""Intro""><b><u>Introduction</u></b></a><p>"
              "ldoss - launch delayed on session start<br>"
              "Is an application launcher, which launches programs an adjustable time after a graphical (X11) session has started.<br>"
			  "This can avoid program crashes on window managers, which do not honour the 'autostart' directory, like fluxbox, where you can only automatically launch programs "
			  "before the window manager itself.<p>"
			  "The application can run in GUI and non GUI mode.<br>"
			  "The GUI mode<br>"
			  "allows for easy editing of the programs to start. These can be defined in a simple text editor window, one program start command including command line options "
			  "per line. If required, the full path to the application must be found with a file manager. Selecting an application via a file dialog is currently not supported "
			  "(would cause overhead for adding/deleting options to that program).<br>"
			  "The non-GUI mode<br>"
			  "selected with the '-l' option, is the way, the program should be started with the window manager (e. g. fluxbox). It will wait an adjustable time to allow the "
			  "window manager to come up and will then start the programs as defined in GUI mode as detached processes. If all programs have been tried to start, ldoss will exit.<p>"
              "<a href=""#Top"">back to top</a><p>"

              "<hr>"
              "<a name=""Usage""><b><u>Starting</u></b></a><p>"
              "ldoss should have been installed in the system menu under: 'Utilities' or launch it by entering just the program name 'ldoss' without any command line options in a "
              "terminal.<p>"
              "This, called without any command line options, will launch the program in a GUI (graphical) environemnt in which you can set:<br>"
              "- the programs to start, one per line in the text edit box, the full command line including any command line options<br>"
              "- the delay, after which the programs should be launched<br>"
              "Hit 'Save' when you are done and the settings will be saved. 'Cancel' will close the dialog windoe without saving anything.<p>"
              "To start the program in launch mode, use the '-l' switch. When called before the window manager, this might require to add a '&' at the end of the command line in a script like:<br>"
              "'ldoss -l &'<br>"
              "This will start the program in non-GUI mode. It will wait the defined time and after that, it will start to launch every defined program with it's command line "
              "options. If the launch was unsuccessful, a short message about this will be send to stdout (not stderr). So starting ldoss from a terminal gives at least the "
              "feedback which service failed to start.<p>"
              "You can define the display to launch the programs on as with any other program by calling ldoss with DISPLAY=:0.0 ...1 ...2:<br>"
              "DISPLAY=:0.2 ldoss -l<br>"
              "will launch all programs on the 3rd display of the 1st x-server. However, all programs will be launched on this screen.<br>"
              "Beside that, some programs understand the -display :0.0 ...1 ...2 command line option. So defining a command to launch e. g. goldendict like this:<br>"
              "goldendict -display :0.1<br>"
              "will launch goldendict on the 2nd display of the 1st x-server.<p>"
              "<a href=""#Top"">back to top</a><p>"

              "<hr>"
              "<a name=""Options""><b><u>Options</u></b></a><p>"
              "Start the program without options in a graphical environment (X11) to set the programs to launch and the delay time.<p>"
              "Start the program with the '-l' options to start in non-GUI mode and start programs after the defined delay.<p>"
              "Any other command line options(s) will lead to a short info on stdout, the console/terminal.<p>"
              "<a href=""#Top"">back to top</a><p>"

              "<hr>"
              "<a name=""Faq""><b><u>FAQ</u></b></a><p>"
              "None so far<p>"
              "Good...<p>"
              "<a href=""#Top"">back to top</a><p>"

              "<hr>"
              "<a name=""Credits""><b><u>Credits</u></b></a><p>"
              "Internal program icons (48x48 svg, stored under /usr/share/ldoss/*.svg) where taken from the theme elementary_2.3 in March 2010:<br>"
              "Created by Daniel Fore, aka DanRabbit, www.elementary-project.com, licensed under GPL(3), http://www.gnu.org/licenses/gpl.html.<br>"
              "document-save.svg as save.svg, help-about.svg as about.svg, help-contents.svg as help.svg, system-shutdown.svg as quit.svg<br>"
              "nothingtosave.svg was made from document-save.svg using inkscape by me, Helge Kortendieck.<br>"
              "Program icon is a scaled down crop from a photo copyright:<br>"
              "ESA Photo: _SCO0674.jpg, Caption: Space Shuttle Endeavour launch, Credits: ESA - S. Corvaja, 2010, ID number: SEMTGDXJB5G<br>"
              "Program and documentation copyright 2010 Helge Kortendieck alan@kasmithee.de<br>"
              "ldoss is released under GPL3 or later<p>"
              "<a href=""#Top"">back to top</a><p>"
              "</body></html>" ) ;
  uih.tb_Help->setHtml( sHelp );
  wHelp.setWindowTitle( tr( "ldoss - help" ) );
//  wHelp.showMaximized();
  wHelp.showFullScreen();
  wHelp.show();
}

void aboutHelp::closeDlg()
{
	wHelp.hide();
	emit sigAhwClosed();
}


#include "abouthelp.moc"
