/***************************************************************************
 *   Copyright (C) 2007-2010 by Helge Kortendieck  alan@kasmitee.de        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.         *
 ***************************************************************************/

#ifndef _LDOSS_H_
#define _LDOSS_H_

#include <QAction>
#include <QMainWindow>
#include <QMenu>
#include <QMenuBar>
#include <QMessageBox>
#include <QPoint>
#include <QSettings>
#include <QSize>
#include <QSpinBox>
#include <QTextEdit>
#include <QTimer>
#include <QToolBar>

#include "ui_ldoss.h"
#include "abouthelp.h"

class Ldoss : public QMainWindow
{
    Q_OBJECT

public:
	Ldoss( QMainWindow* parent = 0 );
		~Ldoss();


private:
//	bool bD;				// shall main program re-read it settings, any changes?
	bool bObjAhw;			// ahw created?
	bool bQuit;				// quitting?
	bool bSetChg;			// settings changed?

	int iD;
	int iD2;

//	QString sDisplayToShowImg;	// display to show image on open acc settings, default = 0:0
//	QString sDisplayToShowInfo;	// display to show image on open acc settings, default = 0:0

	Ui::LdossW uis;				// settings widget

	QAction *aboutAct;
	QAction *exitAct;
	QAction *helpAct;
	QAction *noSaveAct;
	QAction *saveAct;

	QMainWindow wSetDlg;		// settings widget

	QMenu *fileMenu;			// file menu
	QMenu *helpMenu;			// help menu

	QToolBar *toolBar;			// toolbar

	aboutHelp* ahw;				// help widget

private slots:
	void ahwAbout();			// about clicked
	void ahwHelp();				// help clicked
	void ahwCreate( int iD );	// create about/help/error dialog widget
	void ahwClosed();			// ahw widget was closed

	void actionsCreate();
	void menusCreate();
	void toolBarCreate();

	void init();

	void settingsChanged();		// changes to the settings were made

	void setRead();				// read settings
	void setWrite();			// write settings
	void setWritePos();			// write settings, widget pos and size
	
//	void dlgEnableSave();		// enable save button
	void dlgClosePrep();		// prepare closing dialog
	void dlgClose();			// close dialog
	void dlgSave();				// save settings

	signals:
		void sigDlgAbout();		// show about dialog
		void sigDlgHelp();		// show help dialog
};

#endif
